import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.*;

/** Clases GeoCoder, su mision es converir Strings de direcciones en coordenadas de tipo
 * GeoPosition, Esta clase colaborar a la clases map, la cual  fue disenada de manera de que Todos 
 * los metos necesarios para la creacion de un mapa se realizen atravez de la clase map.
 * Para esta clase es necesario entregarle el KEY que requieren los servidores de google para poder utilisarlos. 
 * @author Gunther Bevensee, Claudio Castro, Marcelo Rutte.
 */

class Geocoder {
private final static String ENCODING = "UTF-8";
private final static String KEY = "ABQIAAAAUl6sCK5rxJA5bd8MbcFH_xScaUiBaYN7HR_xAc6Diik1b7EyqBQGYcc5LyRw5qYa7BuBfCR-jZPAFQ";
public static float lon;
public static float lat;



/** 
 * 
 * @return Latitud.
 */
public float getLat()
{
	return (lat);
}
/**
 * 
 * @return Longitud.
 */

public float getLon()
{
	return (lon);
}


/** Almacena una localidad en formato Latitud, Longitud.
 
 */
public static class Location {

/** Constructor.
 * 
 * @param lat1  Latitud de la Localidad
 * @param lon1  Longitud de la Localidad.
 */
private Location (String lat1, String lon1) 
{
lon = StringToFloat(lon1);
lat = StringToFloat(lat1);
}

/**
 * return Un string con la latitud y la longitud.
 */

public String toString () { return "Lat: "+lat+", Lon: "+lon; }
}

/**Convierte  un string en flotante.
 * 
 * @param s Sting que contiene un numero real(double)
 * @return  flotante f.
 */
private static float StringToFloat(String s)
{

	float f=0;
try {
    f = Float.valueOf(s.trim()).floatValue();
    System.out.println("float f = " + f);
 } catch (NumberFormatException nfe) {
    System.out.println("NumberFormatException: " + nfe.getMessage());
 }
 return (f);
}

/**
 * Metodo que que transforma un string en coordenadas enviadas por el servidor de googlemaps.
 * @param address
 * @return 
 * @throws IOException
 */

public static Location getLocation (String address) throws IOException {
BufferedReader in = new BufferedReader (new InputStreamReader (new URL ("http://maps.google.com/maps/geo?q="+URLEncoder.encode (address, ENCODING)+"&output=csv&key="+KEY).openStream ()));
String line;
Location location = null;
int statusCode = -1;
while ((line = in.readLine ()) != null) {
// Format: 200,6,42.730070,-73.690570
statusCode = Integer.parseInt (line.substring (0, 3));
if (statusCode == 200)
location = new Location (
line.substring ("200,6,".length (), line.indexOf (',', "200,6,".length ())),
line.substring (line.indexOf (',', "200,6,".length ())+1, line.length ()));
}
if (location == null) {
switch (statusCode) {
case 400: throw new IOException ("Mal requerimiento");
case 500: throw new IOException ("Error desconocido desde Google Encoder");
case 601: throw new IOException ("Missing query");
case 602: return null;
case 603: throw new IOException ("Problema Legal");
case 604: throw new IOException ("Sin ruta");
case 610: throw new IOException ("Key erronea");
case 620: throw new IOException ("Demasiados requerimientos");
}
}
return location;
}


}