import java.awt.*;
import java.io.IOException;

import javax.swing.*;
import org.jdesktop.swingx.*;
import org.jdesktop.swingx.mapviewer.DefaultTileFactory;
import org.jdesktop.swingx.mapviewer.GeoPosition;
import org.jdesktop.swingx.mapviewer.Waypoint;
import org.jdesktop.swingx.mapviewer.WaypointPainter;
import java.util.*;



/**
 * Superclase de Tipo Mapa.
 * 
 * 		Esta clases es la que creara el usuario que dese crear un mapa, todos los mtodos 
 * necesarios para la creacin y utilizacin de un mapa se accedern a trabes de esta clase.

 * 
 * @author Gunther Bevense,Claudio Castro, Marcelo Rutte
 * 
 * 
*/

public class Map 


{
	
	JXMapKit mapViewer = new JXMapKit();
	static Geocoder geografo = new Geocoder();
        private double d;
	

        /** 
         * Constructor.  Inicializa el mapa.  
         * @param a  Elije centro inicial del mapa, 0 es via del mar, 1 es Valparaso.
         * 
         */


	public  Map (boolean a) throws IOException
	{
		mapViewer.setTileFactory(GoogleMapsTileProvider.getDefaultTileFactory());
               
        GeoPosition vina =new GeoPosition(-33.01784,-71.545501);
        GeoPosition valpo=new GeoPosition(-33.044105,-71.622019);
        
        if(a==false)     
        mapViewer.setAddressLocation(vina);
        if(a==true)
        mapViewer.setAddressLocation(valpo);
        
        //GenerarCoordenadas();
        //ZonaA(coordenadasvina);
     }
	
	/** 
     * Transforma una direccin y la trasforma a coordenadas de latitud y longitud.
     * @param S Direccin a ser trasformado su formato debe ser numero calle, ciudad, pas.
     * @return  retorna las coordenadas de tipo GeoPosition.
     */

	public static GeoPosition getCoordenadas(String S) throws IOException 
	{
		geografo.getLocation(S);
                return(new GeoPosition(geografo.getLat(),geografo.getLon()));
	}

	/** 
     * Retorna la latitud de la direccin S.
     * @param S Direccin a ser transformado su formato debe ser numero calle, ciudad, pas.
     * @return  Retorna la latitud.
     */
	public float getLat(String S) throws IOException 
	{
		geografo.getLocation(S);
                return(geografo.getLat());
	}
	
	/** 
     * Retorna la longitud de la direccin S.
     * @param S Direccin a ser transformado su formato debe ser numero calle, ciudad, pas.
     * @return Retorna la longitud.
     */

        public float getLon(String S) throws IOException 
	{
		geografo.getLocation(S);
                return(geografo.getLon());
	}
        
        /** 
         * Recibe un arreglo de direcciones y retorna un vector con sus respectivas coordenadas.
         * @param lista Contiene un a las direcciones en un arreglo.
         * @param coordenadas vector donde sern contenidas la coordenadas de las direcciones.
         * 
         */

	public void GenerarCoordenadas(String[] lista, Vector coordenadas) throws IOException 
	
	{
	
            for(int i=0;i<lista.length;i++)
            {          
                   		
            	coordenadas.addElement(getCoordenadas(lista[i]));
		
            }
	}
	
	/** 
     * Dibuja en el mapa las coordenadas.
     * @param coordenadas vector que contiene coordenadas.
     * @param coordenadas vector donde sern contenidas la coordenadas de las direcciones.
     */

	public void ZonaA(Vector coordenadas)
	{
		int size,i=0;
	    size=coordenadas.size();
		Set<Waypoint> direcciones = new HashSet<Waypoint>();
		WaypointPainter<JXMapViewer> painter =new WaypointPainter<JXMapViewer>();
		while(i<=size-1)
		{
			direcciones.add(new Waypoint((GeoPosition)coordenadas.elementAt(i)));
			i++;
		}
	
        painter.setWaypoints(direcciones);
        mapViewer.getMainMap().setOverlayPainter(painter);
	}
	
	private  void Agregar()
	{
		GeoPosition vergara =new GeoPosition(-33.025378,-71.514688);
		GeoPosition casino =new GeoPosition(-33.020548,-71.558633);		
        Set<Waypoint> direcciones = new HashSet<Waypoint>();
        direcciones.add(new Waypoint(vergara));
        direcciones.add(new Waypoint(casino));
        WaypointPainter<JXMapViewer> painter =new WaypointPainter<JXMapViewer>();
        painter.setWaypoints(direcciones);
        mapViewer.getMainMap().setOverlayPainter(painter);
           	
	}
	/** 
     * Entrega la referencia del mapa para poder ser almacenado en algn contenedor grafico.
     * @return Referencia al Mapa de tipo JXMAPKIT.
     */

	public JXMapKit GetMap()
	{
		return(mapViewer);
	}
	/** 
     * Setea el centro del mapa.
     * @param xy coordenas a las cuales el mapa cera centrado.
     */
	public void CentrarMapa(GeoPosition xy)
		{
		
		 mapViewer.setCenterPosition(xy);
		
        }
		

	/** 
     * Calcula la distancia de un punto x,y al centro de valparaiso.
     * @param x flotante que corresponde a la latitud.
     * @param y flotante que corresponde a la latitud.
     * @return Double que representa la ditancia.
     *   */
	public double DistanciaValpo(float x,float y){//calcula las distancias desde el centro de valparaiso
        d=Math.sqrt(Math.abs(Math.pow(x+33.044105,2)+Math.pow(y+71.622019,2)));
        return(d);
        }

	
	/** 
     * Calcula la distancia de un punto x,y al centro de vina del mar.
     * @param x flotante que corresponde a la latitud.
     * @param y flotante que corresponde a la latitud.
     * @return Double que representa la ditancia.
     *   */
        public double DistanciaVina(float x,float y){
        d=Math.sqrt(Math.abs(Math.pow(x+33.017840,2)+Math.pow(y+71.545501,2))); 
        return(d);
         }

}

