import java.awt.*;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import org.jdesktop.swingx.*;
import org.jdesktop.swingx.mapviewer.DefaultTileFactory;
import org.jdesktop.swingx.mapviewer.GeoPosition;
import org.jdesktop.swingx.mapviewer.TileFactory;
import org.jdesktop.swingx.JXMapKit.*;
import org.jdesktop.swingx.mapviewer.Waypoint;
import org.jdesktop.swingx.mapviewer.WaypointPainter;
import java.util.HashSet;
import java.util.Set;
import java.awt.event.*;
import java.util.*;

/**Esta clase crea la interfaz grafica para el usuario.
*
* @author Gunther Bevensee, Claudio Castro, Marcelo Rute.
*/

public class SplitFrame extends JFrame{
	
	/**
	* Constructor de la clase, que inicializa el mtodo InitComponents, mtodo que crea la interfaz grafica
	* @param a booleano que indica si la interfaz debe ser creada con referencia a Valparaso o via del mar
	* @throws java.io.IOException
	*/

public SplitFrame(boolean a) throws IOException{
InitComponents(a); 
}

/**
 * Mtodo que crea la pantalla de seleccin de direccin, aqu se ingresa un arreglo de direcciones, que son ordenador por la clase sorter y finalmente las muestra en pantalla en una lista, esta lista se agrega a un splits frame con divisin vertical, el cual posee en el lado derecho el mapa, y en el izquierdo la lista menciona, este splitpanel es ingresado a otro splitpanel dividido de forma horizontal, y lo agrega en la parte superior, en la parte inferior existe un botn que permite volver atrs.
 * @param a booleano que indica si la interfaz debe ser creada con referencia a Valparaso o via del mar
 * @throws java.io.IOException
 */

@SuppressWarnings("unchecked")
public void InitComponents(boolean a) throws IOException{

JSplitPane vertical=new JSplitPane();//crea un panel dividido que contiene un campo arriba y uno abajo
JSplitPane split = new JSplitPane();//crea un panel dividido horizontalmente
JPanel panel2=new JPanel();//crea un panel general
botonAtras = new java.awt.Button();//boton para devolver
botonAtras.setLabel("Volver Atras");
botonAceptar = new java.awt.Button();//boton para finalizar
botonAceptar.setLabel("Aceptar");

botonAtras.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
		               
                setVisible(false);
                new Principal().setVisible(true);
                
                
		}
	});
        


//Geocoder geografo = new Geocoder();

final Map panel = new Map(a);//crea el mapa
setSize(800,600);
split.setDividerLocation(175);

Vector<String> direccion = new Vector<String>();
Integer size, i = 0,u=0;
direccion = Lector.leer(a);
size = direccion.size();
String[] data = new String[(int)size/2];
while (u < size) {
	
	if (u%2 != 0)
	{
	data[i] = direccion.elementAt(u);
	i = i + 1;
	}
	u++;
}
//direccion.copyInto(data);
Vector coordenadasvina = new Vector();// crea el vector de coordenadas para visualizar en el mapa
panel.GenerarCoordenadas(data,coordenadasvina);
panel.ZonaA(coordenadasvina);
panel2.add(botonAtras);//agrega los botones al panel superior
panel2.add(botonAceptar);




final JList dataList = new JList(data);//crea una lista en base al arreglo de direcciones ingresado anteriormente



Vector OrdenValpo = new Vector();//crea un vector para las direcciones de valparaiso
Vector OrdenVina = new Vector();//crea un vector para las direcciones de vina

for(int i1=0;i1<data.length;i1++){
float Lat=panel.getLat((String) dataList.getModel().getElementAt(i1));
float Lon=panel.getLon((String) dataList.getModel().getElementAt(i1));
OrdenValpo.add(i1,new Direccion(i1,data[i1],panel.DistanciaValpo(Lat,Lon)));
OrdenVina.add(i1,new Direccion(i1,data[i1],panel.DistanciaVina(Lat,Lon)));
}//este For ingresa en el vector de direcciones, cada direccion con nombre y la distancia que hay desde este punto al centro de vina o valpo. correspondientemente

Vector VectorStrings=new Vector();//crea un vector para almacenar strings
if(a==true)tamano=OrdenValpo.size();//si se ha ingresado con el boton valparaiso el tamano del arreglo depende de las direcciones de valparaiso
if(a==false)tamano=OrdenVina.size();//si se ha ingresado con el boton vina del mar el tamano del arreglo depende de las direcciones de vina
double[] array=new double[tamano];//crea un arreglo para almacenar las distancias
String[] arrayst=new String[tamano];//crea un areglo para almacenar las direcciones


if(a==true){//si se ha ingresado con valparaiso, agrega al vector de strings cada direciones y al arreglo cada distancia

for(int i1=0;i1<OrdenValpo.size();i1++){
Direccion Dire=(Direccion)OrdenValpo.get(i1);
array[i1]=Dire.getDistancia();
VectorStrings.add(Dire.getDireccion());
}
String s;
s=(String)VectorStrings.elementAt(0);
panel.getCoordenadas(s);

}

if(a==false){//si se ha ingresado con vina del mar, agrega al vector de strings cada direciones y al arreglo cada distancia

for(int i1=0;i1<OrdenVina.size();i1++){
Direccion Dire=(Direccion)OrdenVina.get(i1);
array[i1]=Dire.getDistancia();
VectorStrings.add(Dire.getDireccion());
String s;
s=(String)VectorStrings.elementAt(VectorStrings.size()-1);
panel.getCoordenadas(s);
}



}
VectorStrings.copyInto(arrayst);//copia el vector de strings en un arreglo de strings
final JList dataListV = new JList(arrayst);//crea una lista con los strings
JScrollPane scrollPane = new JScrollPane(dataListV);//crea un panel con scroll con la lista de strings
split.setLeftComponent(scrollPane);//agrega el panel con scroll a la componente izquierda del panel


Sorter sorter= new Sorter(array,arrayst);//crea un elemento de orden
sorter.sort();//ordena los elementos en base a las direcciones y a la vez modifica el arreglo de strings en base a los cambios en las distancias


vertical.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

split.setRightComponent(panel.GetMap());//agrega el mapa a la componente derecha del panel
vertical.setDividerSize(1);
vertical.setDividerLocation(520);
vertical.setTopComponent(split);//agrega el panel divido horizontalmente a la parte superior del panel dividido verticalmente
vertical.setBottomComponent(panel2);//agrega el panel inferior(botones) al panel dividido verticalmente
add(vertical);//agrega el panel vertical al frame
setVisible(false);//hace visible el frame



 MouseListener mouseListener = new MouseAdapter() {
     public void mouseClicked(MouseEvent e) {
         if (e.getClickCount() == 2) {
                    try {
                        int index = dataListV.locationToIndex(e.getPoint());
                        panel.CentrarMapa(panel.getCoordenadas((String) dataListV.getSelectedValue()));//al hacer click sobre una direccion en la lista, centra el mapa en sus coordenadas
                        
                    } catch (IOException ex) {
                        Logger.getLogger(SplitFrame.class.getName()).log(Level.SEVERE, null, ex);
                    }
          }
     }
 };
 dataListV.addMouseListener(mouseListener);
 
this.addWindowListener( new WindowAdapter() {
      public void windowClosing( WindowEvent evt ) {
	System.exit( 0 );
         
      }
    }); 
 
 
}

int tamano = 0;
private java.awt.Button botonAtras;
private java.awt.Button botonAceptar;
public double[] array;
public String[] arrayst;


}
